﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF.Schedule;
using System.Data.OleDb;
using System.Data;

namespace Wpf_C1Scheduler_DataBindings
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        //declare ado objects to be used for binding
        OleDbConnection conn;
        OleDbDataAdapter adapter;
        OleDbCommand cmd;
        DataSet ds;

        public MainWindow()
        {
            InitializeComponent();
            //initialize ado objects
            conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\\..\\Nwind.mdb");
            adapter = new OleDbDataAdapter("select * from Appointments", conn);
            ds = new DataSet();
        }

        private void Grid_Loaded(object sender, RoutedEventArgs e)
        {
            //populate the dataset with the selected records
            adapter.Fill(ds, "Appointments");

            //map the datafields for the Appointment entity
            this.c1Scheduler.DataStorage.AppointmentStorage.Mappings.Body.MappingName = "Description";
            this.c1Scheduler.DataStorage.AppointmentStorage.Mappings.Subject.MappingName = "Subject";
            this.c1Scheduler.DataStorage.AppointmentStorage.Mappings.Location.MappingName = "Location";
            this.c1Scheduler.DataStorage.AppointmentStorage.Mappings.Start.MappingName = "Start";
            this.c1Scheduler.DataStorage.AppointmentStorage.Mappings.End.MappingName = "EndTime";
            this.c1Scheduler.DataStorage.AppointmentStorage.Mappings.AppointmentProperties.MappingName = "Properties";
            this.c1Scheduler.DataStorage.AppointmentStorage.Mappings.IdMapping.MappingName = "AppointmentId";
            this.c1Scheduler.DataStorage.AppointmentStorage.DataSource = ds.Tables[0];
        }

        private void c1Scheduler_AppointmentAdded(object sender, C1.WPF.Schedule.AppointmentActionEventArgs e)
        {            
            string query = "Insert Into Appointments values(@AppointmentId, @Description, @EndTime, @Location, @Start, @Subject, @Properties);";
            cmd = new OleDbCommand(query, conn);
            setParameter(e.Appointment);
            conn.Open();
            cmd.ExecuteNonQuery();
            conn.Close();
            MessageBox.Show("Appointment added successfully!");
        }
        private void setParameter(C1.C1Schedule.Appointment app)
        {
            object[] o = app.Key;
            Guid g = (Guid)o[0];
            cmd.Parameters.AddWithValue("@AppointmentId", g);
            cmd.Parameters.AddWithValue("@Description", app.Body);
            cmd.Parameters.AddWithValue("@EndTime", app.End);
            cmd.Parameters.AddWithValue("@Location", app.Location);
            cmd.Parameters.AddWithValue("@Start", app.Start);
            cmd.Parameters.AddWithValue("@Subject", app.Subject);
            cmd.Parameters.AddWithValue("@Properties", app.GetAppointmentProperties());
        }
        private void c1Scheduler_AppointmentChanged(object sender, C1.WPF.Schedule.AppointmentActionEventArgs e)
        {
            object[] o = e.Appointment.Key;
            Guid g = (Guid)o[0]; 
            string query = "UPDATE Appointments SET Description = @Description, EndTime = @EndTime, Start = @Start, Location = @Location, Subject = @Subject, Properties = @Properties WHERE AppointmentId = @AppointmentId;";
            cmd = new OleDbCommand(query, conn);
            cmd.Parameters.AddWithValue("@Description", e.Appointment.Body);
            cmd.Parameters.AddWithValue("@EndTime", e.Appointment.End);
            cmd.Parameters.AddWithValue("@Start", e.Appointment.Start);
            cmd.Parameters.AddWithValue("@Location", e.Appointment.Location);
            cmd.Parameters.AddWithValue("@Subject", e.Appointment.Subject);
            cmd.Parameters.AddWithValue("@Properties", e.Appointment.GetAppointmentProperties());
            cmd.Parameters.AddWithValue("@AppointmentId", g);
            conn.Open();
            cmd.ExecuteNonQuery();
            conn.Close();
            MessageBox.Show("Appointment Updated!");
        }

        private void c1Scheduler_AppointmentDeleted(object sender, C1.WPF.Schedule.AppointmentActionEventArgs e)
        {   
            object[] o = e.Appointment.Key;
            Guid g = (Guid)o[0];
            cmd = new OleDbCommand("DELETE FROM Appointments WHERE AppointmentId = @AppointmentId", conn);
            cmd.Parameters.AddWithValue("@AppointmentId", g);
            conn.Open();
            cmd.ExecuteNonQuery();
            conn.Close();
            MessageBox.Show("Appointment Deleted!");
        }   
    }
}
